﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using FastColoredTextBoxNS;
using FarsiLibrary.Win;
using System.IO;
using System.Text.RegularExpressions;
using System.Threading;
using com.calitha.goldparser;

namespace RTMALG
{
    public partial class Interfaz : Form
    {
        FastColoredTextBox cajaTexto;
        AutocompleteMenu menuauto;
        bool existeTexto = false;
        EstilosColores estilos = new EstilosColores();
        informacion Boxinf = new informacion();
        menuAutocomplementado autoComplementado = new menuAutocomplementado();
        bool cambio = true;
        public static String nombre_archivo = "";
        private int sizeFont = 13;
        MAR menuMAR;
        MyParser parse = new MyParser();
        
        public Interfaz()
        {
            InitializeComponent();
            CrearContenedor(null);
            menuauto = new AutocompleteMenu(cajaTexto);
            menuauto.SearchPattern = @"[\w\.:=!<>]";
            menuauto.AllowTabKey = true;
            //parse = new MyParser(Application.StartupPath + "\\RMTALG.egt");
            parse.Setup(Application.StartupPath + "\\RMTALG.egt");
        }


        private void CrearContenedor(string fileName)
        {
            try
            {
                cajaTexto = new FastColoredTextBox();
                cajaTexto.Font = new Font("Consolas", 13f);
                cajaTexto.Dock = DockStyle.Fill;
                cajaTexto.ContextMenuStrip = menuDerecho;
                
                cajaTexto.Language = Language.Custom;
                cajaTexto.AddStyle(new MarkerStyle(new SolidBrush(Color.FromArgb(50, Color.Gray))));//same words style
                var Caja = new FATabStripItem(fileName != null ? Path.GetFileName(fileName) : "Nuevo", cajaTexto);
                //cajaTexto.Tag = fileName;

                cajaTexto.Tag = new informacion();
                
                Contenedor.SelectedItem = Caja;
                Contenedor.AddTab(Caja);
                cajaTexto.CommentPrefix = "\x0";
                cajaTexto.LeftBracket = '{';
                cajaTexto.RightBracket = '}';
                cajaTexto.LeftBracket2 = '(';
                cajaTexto.RightBracket2 = ')';
                cajaTexto.ShowFoldingLines = true;
                cajaTexto.BorderStyle = BorderStyle.Fixed3D;
                cajaTexto.VirtualSpace = true;
                cajaTexto.LeftPadding = 17;
                cajaTexto.TabIndex = 5;
                cajaTexto.FindEndOfFoldingBlockStrategy = FindEndOfFoldingBlockStrategy.Strategy1;
                cajaTexto.LineNumberColor = Color.Black;
                cajaTexto.HighlightFoldingIndicator = true;
                cajaTexto.TabLength = 4;
                cajaTexto.IndentBackColor = Color.LightGray;
                cajaTexto.Focus();
                
                cajaTexto.DelayedTextChangedInterval = 1000;
                cajaTexto.DelayedEventsInterval = 1000;
                cajaTexto.TextChanged += new EventHandler<TextChangedEventArgs>(cajaTexto_coloriar);
                cajaTexto.TextChangedDelayed += new EventHandler<TextChangedEventArgs>(cajaTexto_TextChangedDelayed);
                cajaTexto.SelectionChangedDelayed += new EventHandler(cajaTexto_SelectionChangedDelayed);
                // tb.KeyDown += new KeyEventHandler(tb_KeyDown);
                // tb.MouseMove += new MouseEventHandler(tb_MouseMove);
                cajaTexto.HighlightingRangeType = HighlightingRangeType.ChangedRange;

                if (fileName != null)
                    cajaTexto.Text = File.ReadAllText(fileName);
                if (existeTexto == false)
                    cajaTexto.Text = "Rutina Principal\r\nVariables\r\n\r\nInicio\r\n\r\nFin";
                else
                    existeTexto = false;
                cajaTexto.ClearUndo();
                cajaTexto.IsChanged = false;
                cajaTexto.CurrentLineColor = estilos.lineaGuia;
                AutocompleteMenu AutoMenu = new AutocompleteMenu(cajaTexto);
                //imagen
                //AutoMenu.Items.ImageList = ilAutocomplete;
               autoComplementado.Contruir(AutoMenu);
                (cajaTexto.Tag as informacion).AutoMenu = AutoMenu;
                Estado.Panels[0].Text = "Listo";
            }
            catch (Exception ex)
            {
                if (MessageBox.Show(ex.Message, "Error", MessageBoxButtons.RetryCancel, MessageBoxIcon.Error) == System.Windows.Forms.DialogResult.Retry)
                    CrearContenedor(fileName);
            }
        }

        private void cajaTexto_coloriar(object sender, TextChangedEventArgs e)
        {

            Range rango = (sender as FastColoredTextBox).VisibleRange;

            rango.ClearStyle(estilos.AzulStyle);
            rango.SetStyle(estilos.AzulStyle, @"({.*?})|({.*)", RegexOptions.Singleline | SyntaxHighlighter.RegexCompiledOption);
            rango.SetStyle(estilos.AzulStyle, @"({.*?})|(.*})", RegexOptions.Singleline | RegexOptions.RightToLeft | SyntaxHighlighter.RegexCompiledOption);

            
            e.ChangedRange.ClearStyle(estilos.VerdeStyle, estilos.BrownStyle, estilos.GrisStyle, estilos.NaranjaStyle);
            e.ChangedRange.SetStyle(estilos.BrownStyle, @"\b(Entero|Cadena|Caracter|Decimal)\b");
            e.ChangedRange.SetStyle(estilos.GrisStyle, @"""""|@""""|''|@"".*?""|("".*"")|'.*'", SyntaxHighlighter.RegexCompiledOption);
            e.ChangedRange.SetStyle(estilos.VerdeStyle, @"\b(Subrutina|Rutina|Variables|Inicio|Fin|Repetir|FinRepetir|FinSi|Mientras|Hacer|Para|Desde|Hasta|Si|Entonces|De lo contrario|Devolver|Regresar|leer|escribir|raiz)\b");
            e.ChangedRange.SetStyle(estilos.NaranjaStyle, @"\b(\d|\d*|\d.\d|\d*.\d*)\b");

            e.ChangedRange.ClearFoldingMarkers();
            e.ChangedRange.SetFoldingMarkers(@"Inicio\b", @"Fin\b");
            e.ChangedRange.SetFoldingMarkers(@"Variables\b", @"\n\b");
            e.ChangedRange.SetFoldingMarkers(@"Repetir\b", @"FinRepetir\b");
            e.ChangedRange.SetFoldingMarkers(@"Si\b", @"FinSi\b");
            e.ChangedRange.SetFoldingMarkers(@"{", @"}");
        }

        private void cajaTexto_TextChangedDelayed(object sender, TextChangedEventArgs e)
        {
            FastColoredTextBox tb = (sender as FastColoredTextBox);

            string text = (sender as FastColoredTextBox).Text;
            ThreadPool.QueueUserWorkItem(
                (o) => construirMenu(text)
            );
        }

        //Explorar elementos Rutina Subrutina 
        List<ExplorarElemento> explorarElementos = new List<ExplorarElemento>();

        private void construirMenu(string texto)
       {
            try
            {
                List<ExplorarElemento> lista = new List<ExplorarElemento>();
                int lastClassIndex = -1;
                Regex regex = new Regex(@"^((Rutina|Subrutina)\s+[\w<>,\s]+)", RegexOptions.Multiline);
                foreach (Match r in regex.Matches(texto))
                    try
                    {
                        string s = r.Value;
                        int i = s.IndexOfAny(new char[] { '=', '(', '\r' });
                        if (i >= 0)
                            s = s.Substring(0, i);
                        s = s.Trim();

                        var elemento = new ExplorarElemento() { ttulo = s, posicion = r.Index };
                        if (Regex.IsMatch(elemento.ttulo, @"\b(Rutina|Subrutina)\b"))
                        {
                            elemento.ttulo = elemento.ttulo.Substring(elemento.ttulo.LastIndexOf(' ')).Trim();
                            elemento.type = ExplorarElementoTipo.Rutina;
                            lista.Sort(lastClassIndex + 1, lista.Count - (lastClassIndex + 1), new ExplorarElemntoComprar());
                            lastClassIndex = lista.Count;
                        }
                        else
                            if (elemento.ttulo.Contains("("))
                            {
                                var parts = elemento.ttulo.Split('(');
                                elemento.ttulo = parts[0].Substring(parts[0].LastIndexOf(' ')).Trim() + "(" + parts[1];
                                elemento.type = ExplorarElementoTipo.Subrutina;
                            }
                        lista.Add(elemento);
                    }
                    catch { ;}

                lista.Sort(lastClassIndex + 1, lista.Count - (lastClassIndex + 1), new ExplorarElemntoComprar());

                BeginInvoke(
                    new Action(() =>
                    {
                        explorarElementos = lista;
                        menuRutina.RowCount = explorarElementos.Count;
                        menuRutina.Invalidate();
                    })
                );
            }
            catch { ;}
        }

        enum ExplorarElementoTipo
        {
            Rutina, Subrutina
        }

        class ExplorarElemento
        {
            public ExplorarElementoTipo type;
            public string ttulo;
            public int posicion;
        }

        class ExplorarElemntoComprar : IComparer<ExplorarElemento>
        {
            public int Compare(ExplorarElemento x, ExplorarElemento y)
            {
                return x.ttulo.CompareTo(y.ttulo);
            }
        }

      

        DateTime lastNavigatedDateTime = DateTime.Now;

        private void cajaTexto_SelectionChangedDelayed(object sender, EventArgs e)
        {
            var HelpBox = sender as FastColoredTextBox;
            if (HelpBox.Selection.IsEmpty && HelpBox.Selection.Start.iLine < HelpBox.LinesCount)
            {
                if (lastNavigatedDateTime != HelpBox[HelpBox.Selection.Start.iLine].LastVisit)
                {
                    HelpBox[HelpBox.Selection.Start.iLine].LastVisit = DateTime.Now;
                    lastNavigatedDateTime = HelpBox[HelpBox.Selection.Start.iLine].LastVisit;
                }
            }

            //remarcar palabras repetidas
            cajaTexto.VisibleRange.ClearStyle(estilos.Estilo);

            if (!cajaTexto.Selection.IsEmpty)
                return;

            var fragment = cajaTexto.Selection.GetFragment(@"\w");
            string text = fragment.Text;
            if (text.Length == 0)
                return;

            var ranges = cajaTexto.VisibleRange.GetRanges("\\b" + text + "\\b").ToArray();
            if (ranges.Length > 1)
                foreach (var r in ranges)
                    r.SetStyle(estilos.Estilo);
        }

        FastColoredTextBox controlCaja
        {
            get
            {
                if (Contenedor.SelectedItem == null)
                    return null;
                return (Contenedor.SelectedItem.Controls[0] as FastColoredTextBox);
            }

            set
            {
                Contenedor.SelectedItem = (value.Parent as FATabStripItem);
                value.Focus();
            }
        }

        private void AbrirArchivo()
        {

            if (!cajaTexto.Text.Equals("Rutina Principal\r\nVariables\r\n\r\nInicio\r\n\r\nFin"))
            {
                existeTexto = true;
                if (Abrir.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    CrearContenedor(Abrir.FileName);
                    nombre_archivo = Abrir.FileName;
                    menuMAR.agregarArchivo(Abrir.FileName);
                }
            }
            else
            {
                if (Abrir.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    controlCaja.Text = File.ReadAllText(Abrir.FileName);
                    Contenedor.SelectedItem.Title = Path.GetFileName(Abrir.FileName);
                    nombre_archivo = Abrir.FileName;
                    Contenedor.SelectedItem.Tag = Abrir.FileName;
                    controlCaja.IsChanged = false;
                    menuMAR.agregarArchivo(Abrir.FileName);
                }

            }

            Estado.Panels[0].Text = "Listo";
        }


        private bool GuardarArchivo(FATabStripItem tab)
        {
            var BoxSalvar = (tab.Controls[0] as FastColoredTextBox);
            if (tab.Tag == null)
            {
                if (Guardar.ShowDialog() != System.Windows.Forms.DialogResult.OK)
                    return false;
                tab.Title = Path.GetFileName(Guardar.FileName);
                tab.Tag = Guardar.FileName;
            }

            try
            {
                File.WriteAllText(tab.Tag as string, BoxSalvar.Text);
                tab.Title = tab.Title.ToString().Substring(0, tab.Title.ToString().Length - 1);
                cambio = true;
                BoxSalvar.IsChanged = false;
            }
            catch (Exception ex)
            {
                if (MessageBox.Show(ex.Message, "Error", MessageBoxButtons.RetryCancel, MessageBoxIcon.Error) == DialogResult.Retry)
                    return GuardarArchivo(tab);
                else
                    return false;
            }

            BoxSalvar.Invalidate();
            return true;
        }
        

        // menu archivo
        private void nuevoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            CrearContenedor(null);
        }

        private void abrirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AbrirArchivo();
        }

        private void guardarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Contenedor.SelectedItem != null)
                GuardarArchivo(Contenedor.SelectedItem);
        }

        private void guardarcomoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Contenedor.SelectedItem != null)
            {
                string ArchivoInf = Contenedor.SelectedItem.Tag as string;
                Contenedor.SelectedItem.Tag = null;
                if (!GuardarArchivo(Contenedor.SelectedItem))
                    if (ArchivoInf != null)
                    {
                        Contenedor.SelectedItem.Tag = ArchivoInf;
                        Contenedor.SelectedItem.Title = Path.GetFileName(ArchivoInf);
                    }
            }
        }

        private void imprimirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (controlCaja != null)
            {
                var imprimir = new PrintDialogSettings();
                imprimir.Title = Contenedor.SelectedItem.Title;
                imprimir.Header = "&b&w&b";
                imprimir.Footer = "&b&p";
                imprimir.ShowPageSetupDialog = false;
                imprimir.ShowPrintDialog = true;
                imprimir.ShowPrintPreviewDialog = false;
                controlCaja.Print(imprimir);
            }
        }

        private void vistapreviadeimpresiónToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (controlCaja != null)
            {
                var imprimir = new PrintDialogSettings();
                imprimir.Title = Contenedor.SelectedItem.Title;
                imprimir.Header = "&b&w&b";
                imprimir.Footer = "&b&p";
                controlCaja.Print(imprimir);
            }
        }

        private void salirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }


        //menu editar

        private void deshacerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.Undo();
        }

        private void rehacerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.Redo();
        }

        private void cortarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.Cut();
        }

        private void copiarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.Copy();
        }

        private void pegarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.Paste();
        }

        private void seleccionartodoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.SelectAll();
        }

        //menu herramienta

        private void personalizarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.ShowGoToDialog();
        }

        private void opcionesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.ShowFindDialog();
        }

        private void buscarYRemplazarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.ShowReplaceDialog();
        }

        //menu Ejecutar

        private void analisarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bool GuardoAnalisis = true;
            Estado.Panels[0].Text = "Analizando...";
            Listas.code.Clear();
            listaError.Items.Clear();
            Listas.tablaSimbolos.Clear();
            Listas.list_Error.Clear();
            Listas.controlError = 0;
            Listas.controlLinea = 0;
            Listas.controlNum = 0;
            
            Listas.posiciones.Clear();
            var BoxSalvar = (Contenedor.SelectedItem.Controls[0] as FastColoredTextBox);
            if (BoxSalvar.IsChanged)
            {
                if (Contenedor.SelectedItem != null)
                    GuardoAnalisis = GuardarArchivo(Contenedor.SelectedItem);

            }
            if (GuardoAnalisis)
            {
                parse.Parse(new StringReader(controlCaja.Text));
                
                //parse.Parse(controlCaja.Text);
                nombre_archivo = Contenedor.SelectedItem.Title;
                if (Listas.list_Error.Count > 0)
                {
                    Estado.Panels[0].Text = "Analisis Error";
                    generarCodigoToolStripMenuItem.Enabled = false;

                }
                else
                {
                    Estado.Panels[0].Text = "Analisis Correcto";
                    generarCodigoToolStripMenuItem.Enabled = true;
                }
                foreach (Errores paso in Listas.list_Error)
                {
                    ListViewItem list = new ListViewItem(paso.retornarError());
                    listaError.Items.Add(list);
                }
            }
        }

        //Barra de Herramienta 

        private void nuevoToolStripButton_Click(object sender, EventArgs e)
        {
            CrearContenedor(null);
        }

        private void abrirToolStripButton_Click(object sender, EventArgs e)
        {
            AbrirArchivo();
        }

        private void guardarToolStripButton_Click(object sender, EventArgs e)
        {
            if (Contenedor.SelectedItem != null)
                GuardarArchivo(Contenedor.SelectedItem);
        }

        private void imprimirToolStripButton_Click(object sender, EventArgs e)
        {
            if (controlCaja != null)
            {
                var imprimir = new PrintDialogSettings();
                imprimir.Title = Contenedor.SelectedItem.Title;
                imprimir.Header = "&b&w&b";
                imprimir.Footer = "&b&p";
                imprimir.ShowPageSetupDialog = false;
                imprimir.ShowPrintDialog = true;
                imprimir.ShowPrintPreviewDialog = false;
                controlCaja.Print(imprimir);
            }
        }

        private void cortarToolStripButton_Click(object sender, EventArgs e)
        {
            controlCaja.Cut();
        }

        private void copiarToolStripButton_Click(object sender, EventArgs e)
        {
            controlCaja.Copy();
        }

        private void pegarToolStripButton_Click(object sender, EventArgs e)
        {
            controlCaja.Paste();
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            controlCaja.Undo();
        }

        private void rehacertoolStripButton2_Click(object sender, EventArgs e)
        {
            controlCaja.Redo();
        }

        private void ayudaToolStripButton_Click(object sender, EventArgs e)
        {

        }

        //cargar MAR (menu de archivos resientes)
        private void Interfaz_Load(object sender, EventArgs e)
        {
            menuMAR = new MAR("Interfaz", archivoToolStripMenuItem, 10);
            menuMAR.archivoSeleccionado += menuMAR_archivoSeleccionado;
        }

        private void menuMAR_archivoSeleccionado(string nombreArchivo)
        {
            AbrirArchivoClick(nombreArchivo);
        }

        public void AbrirArchivoClick(string nombre)
        {
            try
            {
                if (!cajaTexto.Text.Equals("Rutina Principal\r\nVariables\r\n\r\nInicio\r\n\r\nFin"))
                {
                    existeTexto = true;
                    CrearContenedor(nombre);
                    Contenedor.SelectedItem.Tag = nombre;
                }
                else
                {
                    controlCaja.Text = File.ReadAllText(nombre);
                    Contenedor.SelectedItem.Title = Path.GetFileName(nombre);
                    nombre_archivo = nombre;
                    Contenedor.SelectedItem.Tag = nombre;
                    controlCaja.IsChanged = false;
                }
            }
            catch (Exception e)
            {
                menuMAR.quitarArchivo(nombre);
            }
        }

        //menu derecho

        private void cortarToolStripMenuItem1_Click(object sender, EventArgs e)
        {
             controlCaja.Cut();
        }

        private void copiarToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            controlCaja.Copy();
        }

        private void pegarToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            controlCaja.Paste();
        }

        private void desaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.Undo();
        }

        private void rehacerToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            controlCaja.Redo();
        }

        private void irALineaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.ShowGoToDialog();
        }

        private void buscarToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            controlCaja.ShowFindDialog();
        }

        private void bsucarYRemplazarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            controlCaja.ShowReplaceDialog();
        }

        //watch dog vefiricador timer hilo tick
        private void verificar_Tick(object sender, EventArgs e)
        {
            Estado.Panels[1].Text = "Lineas: "+controlCaja.LinesCount.ToString();
            int temp = controlCaja.Selection.Start.iLine + 1;
            Estado.Panels[2].Text = "Linea: " + temp;
            Estado.Panels[3].Text = "Col: " + controlCaja.Selection.Start.iChar.ToString();
            if (controlCaja != null && Contenedor.Items.Count > 0)
            {
                var auxBox = controlCaja;
                guardarToolStripButton.Enabled = guardarToolStripMenuItem.Enabled = guardarcomoToolStripMenuItem.Enabled = auxBox.IsChanged;
                guardarcomoToolStripMenuItem.Enabled = true;
                pegarToolStripButton.Enabled = pegarToolStripMenuItem.Enabled = true;
                //cortarToolStripButton.Enabled = cortarToolStripMenuItem.Enabled = !auxBox.Selection.IsEmpty;
                imprimirToolStripButton.Enabled = imprimirToolStripMenuItem.Enabled = vistapreviadeimpresiónToolStripMenuItem.Enabled = true;
            }
            else
            {
                guardarToolStripButton.Enabled = guardarcomoToolStripMenuItem.Enabled = false;
                guardarcomoToolStripMenuItem.Enabled = false;
                pegarToolStripButton.Enabled = pegarToolStripMenuItem.Enabled = false;
                //cortarToolStripButton.Enabled = cortarToolStripMenuItem.Enabled = false;
                imprimirToolStripButton.Enabled = imprimirToolStripMenuItem.Enabled = vistapreviadeimpresiónToolStripMenuItem.Enabled = false;
                //dataGridView1.RowCount = 0;
            }

            if (controlCaja.IsChanged)
            {
                string verificarCambio = Contenedor.SelectedItem.Title.Substring(Contenedor.SelectedItem.Title.Length-1,1);
                if(!verificarCambio.Equals("*"))
                Contenedor.SelectedItem.Title += "*";
                cambio = false;
            }
        }

        //evento contenedor de caja para guardar eventos contenedor
        private void Contenedor_TabStripItemClosing(TabStripItemClosingEventArgs e)
        {
            if ((e.Item.Controls[0] as FastColoredTextBox).IsChanged)
            {
                switch (MessageBox.Show("¿Desea guardar los cambios realizados en " + e.Item.Title + " ?", "Guardar", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Information))
                {
                    case System.Windows.Forms.DialogResult.Yes:
                        if (!GuardarArchivo(e.Item))
                            e.Cancel = true;
                        break;
                    case DialogResult.Cancel:
                        e.Cancel = true;
                        break;
                }
            }
        }

        private void Contenedor_TabStripItemSelectionChanged(TabStripItemChangedEventArgs e)
        {
            Estado.Panels[0].Text = "Listo";
            menuRutina.Rows.Clear();
            string text = controlCaja.Text;
            ThreadPool.QueueUserWorkItem(
                (o) => construirMenu(text)
            );
        }

        //evento cierre para guardar
        private void Interfaz_FormClosing(object sender, FormClosingEventArgs e)
        {
            List<FATabStripItem> list = new List<FATabStripItem>();
            foreach (FATabStripItem tab in Contenedor.Items)
                list.Add(tab);
            foreach (var tab in list)
            {
                TabStripItemClosingEventArgs args = new TabStripItemClosingEventArgs(tab);
                Contenedor_TabStripItemClosing(args);
                if (args.Cancel)
                {
                    e.Cancel = true;
                    return;
                }
                Contenedor.RemoveTab(tab);
            }
        }

        //click en el error
        private void listaError_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (controlCaja != null)
            {
                int posicion = controlCaja.Selection.Start.iLine;
                controlCaja.GoEnd();
                controlCaja.SelectionStart = Listas.posiciones[Int32.Parse(listaError.SelectedItems[0].SubItems[0].Text) - 1];
                controlCaja.DoSelectionVisible();
                controlCaja.Focus();

            }
        }


        //eventos menu Rutina Subrutina
        private void menuRutina_CellValueNeeded(object sender, DataGridViewCellValueEventArgs e)
        {
            try
            {
                ExplorarElemento item = explorarElementos[e.RowIndex];
                if (e.ColumnIndex == 1)
                    e.Value = item.ttulo;
                else
                    switch (item.type)
                    {
                        case ExplorarElementoTipo.Rutina:
                            e.Value = global::RTMALG.Properties.Resources.icon_component;
                            return;
                        case ExplorarElementoTipo.Subrutina:
                            e.Value = global::RTMALG.Properties.Resources.icon_component;
                            return;
                    }
            }
            catch { ;}
        }

        private void menuRutina_CellMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            if (controlCaja != null)
            {
                var elemento = explorarElementos[e.RowIndex];
                controlCaja.GoEnd();
                controlCaja.SelectionStart = elemento.posicion;
                controlCaja.DoSelectionVisible();
                controlCaja.Focus();
            }
        }

        private void generarCodigoToolStripMenuItem_Click(object sender, EventArgs e)
        {

            /*Listas.code.Insert(0, "class " + Contenedor.SelectedItem.Title.Substring(0, Contenedor.SelectedItem.Title.Length-4) + "\n{\n");
            Listas.code.Append("\n}\n");*/
            SaveFileDialog guardarCodigo = new SaveFileDialog();
            guardarCodigo.Title = "Guardar Codigo";
            guardarCodigo.Filter = "Archivo de Texto (.java) |*.java";

            guardarCodigo.DefaultExt = "java";
            if (guardarCodigo.ShowDialog() == DialogResult.OK)
            {
                string ruta = guardarCodigo.FileName;

                //FileStream fs = new FileStream(ruta, FileMode.Open, FileAccess.Write);
                Listas.code.Insert(0, "class " + Path.GetFileName(guardarCodigo.FileName).Substring(0,Path.GetFileName(guardarCodigo.FileName).IndexOf('.')) + "\n{\n");
                Listas.code.Append("\n}\n");
                StreamWriter fichero = new StreamWriter(ruta);
                fichero.Write(Listas.code.ToString());
                fichero.Close();
                //fs.Close();
                generarCodigoToolStripMenuItem.Enabled = false;
            }
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (sizeFont <= 21)
            {
                sizeFont += 1;
                controlCaja.Font = new Font("Consolas", sizeFont);
            }
        }

        private void toolStripButton1_Click_1(object sender, EventArgs e)
        {
            if (sizeFont >= 7)
            {
                sizeFont -= 1;
                controlCaja.Font = new Font("Consolas", sizeFont);
            }
        }
    }
}
