﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Windows.Forms;

namespace RTMALG
{
    public class MAR
    {
        private string nombreAplicacion;
        private int numArchivos;
        private List<FileInfo> infArchivos;
        private ToolStripMenuItem menu;
        private ToolStripSeparator separador;
        private ToolStripMenuItem[] menuArray;
        //delegado que se activa al seleccionar un archivo de la lista MAR
        public delegate void ArchivoSeleccionado(string nombreArchivo);
        public event ArchivoSeleccionado archivoSeleccionado;

        public MAR(string nombreAppp, ToolStripMenuItem menuApp, int numArchivosapp)
        {
            nombreAplicacion = nombreAppp;
            menu = menuApp;
            numArchivos = numArchivosapp;
            infArchivos = new List<FileInfo>();

            separador = new ToolStripSeparator();
            separador.Visible = false;
            menu.DropDownItems.Add(separador);

            menuArray = new ToolStripMenuItem[numArchivos+1];
            for(int paso = 0; paso < numArchivos; paso++)
            {
                menuArray[paso] = new ToolStripMenuItem();
                menuArray[paso].Visible = false;
                menu.DropDownItems.Add(menuArray[paso]);
            }

            cargarArchivos();

            mostrarArchivos();

        }


        public void cargarArchivos()
        {
            for(int paso = 0; paso <numArchivos; paso++)
            {
                string nombreArchivo =(string) RegistryTools.GetSetting(nombreAplicacion, "FilePath"+ paso.ToString(), "");
                if (nombreArchivo != "")
                    infArchivos.Add(new FileInfo(nombreArchivo));
            }
        }


        public void guardarArchivo()
        {
            eliminarHistorial();

            int indice = 0;
            foreach (FileInfo inf in infArchivos)
            {
                RegistryTools.SaveSetting(nombreAplicacion, "FilePath"+indice.ToString(), inf.FullName);
                indice++;
            }
        }

        private void quitarArchivoInf(string nombreArchivoQuitar)
        {
            for (int x = infArchivos.Count - 1; x >= 0; x--)
                if (infArchivos[x].FullName == nombreArchivoQuitar)
                    infArchivos.RemoveAt(x);
        }

        public void agregarArchivo(string nombreArchivoAgregar)
        {
            //remover archivo si existe
            quitarArchivoInf(nombreArchivoAgregar);

            infArchivos.Insert(0, new FileInfo(nombreArchivoAgregar));
            mostrarArchivos();
            guardarArchivo();
        }

        public void quitarArchivo(string nombreA)
        {
            quitarArchivoInf(nombreA);
            mostrarArchivos();
            guardarArchivo();
        }

        public void mostrarArchivos()
        {
            separador.Visible = (infArchivos.Count > 0);

            for (int x = 0; x < infArchivos.Count; x++)
            {
                menuArray[x].Text = string.Format("&{0} {1}", x + 1, infArchivos[x]);
                menuArray[x].Visible = true;
                menuArray[x].Tag = infArchivos[x];
                menuArray[x].Click -= Archivo_Click;
                menuArray[x].Click += Archivo_Click;
            }

            for (int x = infArchivos.Count; x < numArchivos; x++)
            {
                menuArray[x].Visible = false;
                menuArray[x].Click -= Archivo_Click;
            }

        }

        public void eliminarHistorial()
        {
            for (int x = 0; x < numArchivos; x++)
                RegistryTools.DeleteSetting(nombreAplicacion, "FilePath"+x.ToString());
        }

        private void Archivo_Click(object sender, EventArgs e)
        {
            if (archivoSeleccionado != null)
            {
                ToolStripMenuItem menuind = sender as ToolStripMenuItem;
                FileInfo inf = menuind.Tag as FileInfo;
                archivoSeleccionado(inf.FullName);
            }
        }
    }
}
